
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>你可能不知道的陷阱：C#委托和事件的困惑 / iVAN</title>

    <meta name="description" content="你可能不知道的陷阱：C#委托和事件的困惑 一. 问题引入          通常,一个C语言学习者登堂入室的标志就是学会使用了指针,而成为高手的标志又是&quot;玩转指针&quot;.指针是如此奇妙,通过一个地址,可以指向一个数,结构体,对象,甚至函数.最后的一种函数,我们称之为&quot;函数指针&quot;(和&quot;指针函数&quot;可不一样!)就像如下的代码: int func(int x); /* 声明一个函数 */ int (*f) (int x); /* 声明一个函数指针 */ f=func; /* 将func函数 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">你可能不知道的陷阱：C#委托和事件的困惑</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>一. 问题引入</h1>
<p>         通常，一个C语言学习者登堂入室的标志就是学会使用了指针，而成为高手的标志又是“玩转指针”。指针是如此奇妙，通过一个地址，可以指向一个数，结构体，对象，甚至函数。最后的一种函数，我们称之为“函数指针”（和“指针函数”可不一样！）就像如下的代码：</p>
<pre><code>int func(int x); /* 声明一个函数 */
    int (*f) (int x); /* 声明一个函数指针 */
   f=func; /* 将func函数的首地址赋给指针f */</code></pre>
<p>     C语言因为函数指针获得了极强的动态性，因为你可以通过给函数指针赋值并动态改变其行为，我曾在单片机上写的一个小系统中，任务调度机制玩的就是函数指针。</p>
<p>　　在.NET时代，函数指针有了更安全更优雅的包装，就是委托。而事件，则是为了限制委托灵活性引入的新“委托”（之所以为什么限制，后面会谈到）。同样，熟练掌握委托和事件，也是C#登堂入室的标志。有了事件，大大简化了编程，类库变得前所未有的开放，消息传递变得更加简单，任何熟悉事件的人一定都深有体会。</p>
<p>　　但你也知道，指针强大，高性能，带来的就是危险，你不知道这个指针是否安全，出了问题，非常难于调试。事件和委托这么好，可是当你写了很多代码，完成大型系统时，心里是不是总觉得怪怪的？有当年使用指针时类似的感觉？</p>
<p>　　如果是的话，请看如下的问题：</p>
<ol>
<li> 若多次添加同一个事件处理函数时，触发时处理函数是否也会多次触发？</li>
<li> 若添加了一个事件处理函数，却执行了两次或多次”取消事件“，是否会报错？</li>
<li>  如何认定两个事件处理函数是一样的？ 如果是匿名函数呢？</li>
<li> 如果不手动删除事件函数，系统会帮我们回收吗？</li>
<li> 在多线程环境下，挂接事件时和对象创建所在的线程不同，那事件处理函数中的代码将在哪个线程中执行？</li>
<li>  当代码的层次复杂时，开放委托和事件是不是会带来更大的麻烦？</li>
</ol>
<p>      列下这些问题，下面就让我们讨论这些”尖酸刻薄“的问题。</p>
<h1>二. 事件订阅和取消问题</h1>
<p>     我们考虑一个典型的例子：加热器，加热器内部加热，在达到温度后通知外界”加热已经完成“。 尝试写下如下测试类：</p>
<pre><code>///
   /// 热水器
   ///
   public class Heater
   {
       public event EventHandler OnBoiled;
       private  void RasieBoiledEvent()
       {
           if(OnBoiled==null)
           {
               Console.WriteLine("加热完成处理订阅事件为空");
           }
           else
           {
               OnBoiled(this, new EventArgs());
           }
       }
       private Thread heatThread;
       public void Begin()
       {
           heatTime = 5;
           heatThread = new Thread(new ThreadStart(Heat));
           heatThread.Start();
           Console.WriteLine("加热器已经开启", heatTime);

       }
       private int heatTime;
       private void Heat()
       {
           while (true)
           {
               Console.WriteLine("加热还需{0}秒", heatTime);

               if (heatTime == 0)
               {
                   RasieBoiledEvent();
                    return;
               }
               heatTime--;
               Thread.Sleep(1000);

           }
       }
   }</code></pre>
<p>    我们有意将事件挂载了两次，看看执行效果:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzM2NTQtZGVlMWI5ZDc1ODVlNGYyOGFkY2ExZjhjZWE5MWVhMDQuanBn.jpg"></p>
<p>     很明显，<strong>如果多次挂载同一事件处理函数，函数将会执行多次。</strong></p>
<p>    这就是<strong>第一个问题的答案</strong>。</p>
<pre><code>接下来，我们将上文中main函数中红色代码替换成如下蛋疼的代码：
test.OnBoiled += TestOnBoiled;
test.OnBoiled -= TestOnBoiled;
test.OnBoiled -= TestOnBoiled;</code></pre>
<p>   在实际开发中，这种情况是很普遍的，谁都有可能取消订阅多次，结果如何呢？</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzM3MjktYTNjNjk2ZGRmNmNhNGExMmEzNzIwODE1MjdhNjA0ZTAuanBn.jpg"></p>
<p>   在执行过程中，删除两次事件没有报错，但当触发事件时，由于事件订阅列表为空，所以，第二个问题的答案：<br /><strong>   多次删除同一事件是不会报错的，即使事件只被订阅了一次。若出现订阅三次，取消订阅两次时，依旧执行一次。</strong></p>
<p>   这个事情是好理解的，事件列表，实际上就是List，最简单的增删问题。</p>
<h1>三. 有了匿名函数后？</h1>
<p><strong>      </strong>自从学习匿名函数后，笔者就特别喜欢用它，除非代码量特别长，否则十行之内的事件订阅，我都会用匿名函数。可是事情变得有意思了，写了匿名函数后，几乎没人记得取消订阅，那么，发生了什么事情呢？</p>
<p>      和上次一样，我们将前面红色代码改成下面的样子:</p>
<pre><code>test.OnBoiled += (s, e) =&gt; Console.WriteLine("加热完成事件被调用");&lt;br&gt;test.OnBoiled -= (s, e) =&gt; Console.WriteLine("加热完成事件被调用");&lt;br&gt;test.Bein();</code></pre>
<p>Resharper直接给我画了灰线，如下图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzM4MDktZjM1NWQ3YzA1Mjg0NDRlNjg4NWVmMmEzZDkyNTFhODkuanBn.jpg"></p>
<p>我估计情况不太乐观，执行之后：</p>
<p>    <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzM4NDQtYTFjMzMxMmQ2MjY3NDg1N2JiNjY0MzMyOWEyN2MzNmUuanBn.jpg"></p>
<p>      果然！加热完成事件还是被调用了，也就是说，<strong>看着形式完全一致的两个匿名函数，编译器生成的方法签名是不一致的，根本就是两个不同的函数。因此，匿名函数完全没法取消订阅！ 这是第三个问题的答案。</strong></p>
<p><strong>      </strong>事件不能被取消订阅！这下可惨了，我真的要取消怎么办？没办法，只能乖乖的写完整的事件函数。匿名方法虽好，千万别用过头。</p>
<p>      但是，真正麻烦的问题来了，一个复杂的动态系统中，一定随时会有大量的对象生成和销毁，你也一定会给它订阅一些事件，当你用匿名函数后，这些函数是不是就像死神一样，一直掐着你的脖子？ 如果事件处理函数涉及重要操作，比如给对方付款，执行多次你是不是就要哭死了？</p>
<h1>  四. 垃圾回收和事件</h1>
<p>　　垃圾回收机制搀和进来后，故事变的更有意思了。</p>
<p>　　 我“殷切”的希望，垃圾回收器会帮我解决第三节最后一段谈到的问题，帮我收拾掉那些函数，那真实的情况呢？我们做个试验：</p>
<p>　　同样的，替换掉红色部分：</p>
<pre><code>test.OnBoiled += (s, e) =&gt; Console.WriteLine("加热完成事件被调用");
test=new Heater();
GC.Collect();  //强制垃圾回收实际上可有可无
test.Bein();</code></pre>
<p>　下面是执行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzM5MjAtYWY3ZDkzYzgxZDBhNDE2ZjllZTkxZDA1NzMzMzg1MTguanBn.jpg"></p>
<p>　　哈，起码在我更新了对象引用<strong>，new了新对象之后，原来的匿名事件确实没有了</strong>。看来编译器还是够意思的。</p>
<p>　　可是，多数实际开发情况中，我们很少直接new一个对象覆盖掉原来的引用。而是重新new了一个对象出来。这种情况的代码如下</p>
<pre><code>test.OnBoiled += (s, e) =&gt; Console.WriteLine("加热完成事件被调用");
            var heaters = new List() { test, test };
            heaters.Clear();
            test.Begin();
            test = null;
            GC.Collect(); </code></pre>
<p>　　执行结果如下图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzM5NTEtOTNkZTg0Y2I2ZDcxNDkyNzg5MTA1Njc1MGZjYjc5MGYuanBn.jpg"></p>
<p>　　这种情况下，<strong>test即使被赋值为null，事件还是会乖乖执行，因为是匿名函数，你也没法取消订阅，而GC强制收集也没用！</strong> 这就是我们真实场景中最可怕的事情，你认为它已经消失了，可是它还挂在事件上！</p>
<p>　　其实这里有个破绽：Heater类里开了线程，我即使赋值为null，线程肯定还没有被销毁，事件确实可能会执行，时间所限，我没有尝试在写一个类测试不开线程的情况，有兴趣的读者可以帮忙试一试。</p>
<p>　　而且，经过我查阅资料，<strong>当你的对象订阅了外部的事件，而又没有取消订阅，那么该对象是不会被GC回收的！这会造成很恐怖的问题，产生了几千万个对象没法被回收。可是，匿名函数让我怎么么取消订阅？！ </strong></p>
<p>　　所以我们得到了结论，<strong>除非确实是一般场景，比如界面开发的window，生成了一直存在，或者在应用程序关闭时回收，否则少用匿名函数吧！记得取消事件订阅！否则会是非常麻烦的事情！</strong></p>
<p> </p>
<h1>五.高潮： 多线程和事件</h1>
<p>      多线程本来就是程序员头疼的问题，笔者在多线程知识上只是入门，没开发过高并发系统，倒是经常用并行库加速算法执行。 让我们看看多线程和事件两个最难搞的东西纠缠在一起时是个什么样子。</p>
<p>      一种常见的场景，是事件处理很耗时，比如执行长时间的IO操作，或者进行了复杂的数学计算，我们不想影响主线程，那么你想当然的会通过多线程的方法解决。</p>
<p>      创建对象的线程，一般是主线程（或者UI线程），<strong>那么，怎么让事件处理函数在另外一个线程执行呢？ 你真的保证处理函数在另外一个线程中执行了？</strong>异步调用？好办法，不过我们此处不说这个。</p>
<p> </p>
<p>//////////////////**************///////////////////////////</p>
<p>修正：经过了重新的测试，发现我的测试用例写的有问题，为了让Heater类自己触发事件，我在内部写了一个新线程，导致测试不准确。</p>
<p>结论应该是： 不论是不是在多线程环境下，<strong>事件处理函数一定在触发事件位置所在的线程中，和事件订阅者的创建线程，订阅事件时所在的线程无关</strong>。。。。。<strong>。我第五节的内容，有多半都是错的。</strong>。。。</p>
<p>因此，若是触发事件所在线程是主线程的话，基本上只能用我提出的第二种做法，通过事件内部使用线程池来执行了。感谢 <a href="http://www.cnblogs.com/WestContinent/" rel="external nofollow noreferrer">West Continent</a> 的讨论。</p>
<p>/////////////////*************/////////////////////</p>
<p><strong> 1. 新建线程方法：</strong></p>
<p>     初学者会这么做：</p>
<pre><code>test.OnBoiled += (s, e) =&gt;
                {
                    var newThread = new Thread(
                        new ThreadStart(
                            () =&gt;
                                {
                             Thread.Sleep(2000); //模拟长时间操作
                                    Console.WriteLine("总算把热好的水加到了暖瓶里");
                                }));
                    newThread.Start();
                };
            test.Begin();</code></pre>
<p><strong>2. 线程池</strong></p>
<p> </p>
<p>　　采用.NET 4.0的线程池试试看，代码如下：</p>
<pre><code>var mainThread = Thread.CurrentThread;
            test.OnBoiled += (s, e) =&gt;
                {
                    ThreadPool.QueueUserWorkItem((d) =&gt;
                        {
                            Thread.Sleep(2000); //模拟长时间操作
                            Console.WriteLine("总算把热好的水加到了暖瓶里");
                            if (Thread.CurrentThread != mainThread)
                            {
                                Console.WriteLine("两者执行的是不同的线程");
                            }
                            else
                            {
                                Console.WriteLine("两者执行的是相同的线程");
                            }
                        });
                };
            test.Begin();</code></pre>
<p>　　我们通过缓存主线程，并比较处理函数中的线程，得到结果如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzQwMjctM2MwODRiYjM0ZTQ2NDM1MmIxNzM3NjgxYzU1MGM5MTMuanBn.jpg"></p>
<p> </p>
<p>　　确实，<strong>采用线程池时，会是两个是不一样的线程，线程池由于内部做了管理，因此可以有效的利用线程，避免疯狂新开线程造成的严重的性能问题。</strong></p>
<p>　　可是，我觉得还是麻烦，尤其是有多种事件时，挨个写线程池还是太麻烦了。那么，我们是不是有两种方案？</p>
<p>      一种是将构造函数写在一个新线程中，另外一种是将事件订阅函数写在新线程中，两者会发生怎样的情况呢？</p>
<p> </p>
<p><strong>3. 对象的构造函数处在新线程时：</strong></p>
<p>　　如下测试代码：</p>
<pre><code>var mainThread = Thread.CurrentThread;
            var autoResetEvent = new AutoResetEvent(false);  //通过信号机制保证对象首先被创建
            ThreadPool.QueueUserWorkItem((d) =&gt;
                {
                    test=new Heater();
                    autoResetEvent.Set();
                });
            autoResetEvent.WaitOne();
            test.OnBoiled += (s, e) =&gt; Console.WriteLine(Thread.CurrentThread != mainThread ? "两者执行的是不同的线程" : "两者执行的是相同的线程");
            test.Begin();</code></pre>
<p>　代码值得一提的是，为了保证对象被首先创建，采用了信号机制实现线程同步，当创建后，主线程才会往下执行，否则会抛出空引用的异常.</p>
<p>　　结果如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzQxNDAtMDVhMDBmZjg1YTU5NGE5ZjgzMjZmNTBkNTAyZjllMWEuanBn.jpg"></p>
<p>　　可见： <strong>主线程称为Main, 若对象构造函数在B线程执行，事件不在主线程中执行。那是不是在B线程中执行呢？暂时还不知道。</strong></p>
<p><strong>4. 对象的事件订阅函数处在新线程时：</strong></p>
<p>　　在另外一个线程里创建对象是更麻烦的，你要解决线程同步问题，恶心不，哈哈。</p>
<p>　　那么，若订阅事件的代码在线程B时，情况是怎样的呢？</p>
<pre><code>var mainThread = Thread.CurrentThread;
            ThreadPool.QueueUserWorkItem((d) =&gt;
                {
                    var bThread = Thread.CurrentThread;
                    test.OnBoiled += (s, e) =&gt;
                        {
                            if(Thread.CurrentThread == mainThread )
                                Console.WriteLine("事件在主线程中执行");
                            else if (bThread==Thread.CurrentThread)
                            {
                                Console.WriteLine("事件在订阅事件的线程B中执行");
                            }
                            else
                            {
                                Console.WriteLine("事件在第三个线程中执行");
                            }
                        };
                });

            test.Begin();</code></pre>
<p>　　结论：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI4NzA2MC8yMDEzMDMvMTUyMzQyMDgtODkzYWQ2NDI4YTY2NDIwNWJlMjcxMTkwMGIwZTJiZDEuanBn.jpg"></p>
<p>　　说实话，我看到这个场景的时候大吃一惊，居然<strong>执行事件的代码不在主线程，不在订阅事件的线程，而在另外一个第三者线程！这可能就是线程池的无敌之处吧，它连事件订阅函数都给托管了！真是碉堡了！！</strong></p>
<p>　　不过，管它是什么线程里执行，反正我主线程是不会被堵塞了，哈哈.</p>
<h1>六.结语</h1>
<p>      本来想今天把最后一个问题都解决的，可是时间实在太晚，而且文章已经够长了。<strong>不妨最后一个问题，“在复杂软件环境下，如何理性正确的使用委托和事件”放在第二部分吧</strong>。有些问题我也没搞清，在做实验的情况下，才逐渐接近结论。 写完这篇文章，我深有收获。</p>
<p>     其实，按照惯例，应该把IL代码好好搞出来给大家看才算是“专业”的选择，不过我确实不懂IL，就不拿出来丢人了，高手们请自行脑补。</p>
<p>      本文介绍了C#的委托和事件的订阅和取消订阅，并在匿名函数和多线程两个环境下讨论了一些问题。<strong>如果你觉得这篇文章对你有帮助，请点一下推荐</strong>，若有任何问题，欢迎留言讨论，共同学习。</p>
<p>     测试代码见<a href="http://files.cnblogs.com/buptzym/EventTest.rar" rel="external nofollow noreferrer">附件</a>，请将不同Region的代码解开注释进行测试。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 06:06:56</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>你可能不知道的陷阱：C#委托和事件的困惑的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOlXVRb.html" rel="bookmark">编写高质量代码改善C&num;程序的157个建议&lbrack;C&num;闭包的陷阱、委托、事件、事件模型&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:编写高质量代码改善C#程序的157个建议[C#闭包的陷阱.委托.事件.事件模型] 前言 本文已更新至http://www.cnblogs.com/aehyok/p/3624579.html .本文主要学习记录以下内容: 建议38.小心闭包中的陷阱 建议39.了解委托的实质 建议40.使用event关键字对委托施加保护 建议41.实现标准的事件模型 建议38.小心闭包中的陷阱 首先我们先来看一段代码: class Program { static void Main(string[] arg			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myd1ykb.html" rel="bookmark">你可能不知道的陷阱&comma; IEnumerable接口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  1.  IEnumerable 与  IEnumerator          IEnumerable枚举器接口的重要性,说一万句话都不过分.几乎所有集合都实现了这个接口,Linq的核心也依赖于这个万能的接口.C语言的for循环写得心烦,foreach就顺畅了很多.          IEnumerable只有一个抽象方法:GetEnumerator(),而IEnumerator又是一个迭代器接口,真正实现了访问集合的功能.  IEnumerator只有一个Current属性,两个方法Mov			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAANJ2M.html" rel="bookmark">解惑答疑：C&num;委托和事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				相信很多人一直为C#委托和事件所困惑,尤其是C#的初学者,学到这一部分会感觉比较困难,很有可能就放弃了,而且.NET对委托和事件封装得挺好,一般都不怎么用到自定义的委托和事件,所以放弃学习该技术就有了借口! 网上也有不少此类的文章,最具代表性的是张子阳的C#中的委托和事件这篇,写得的确很好,得到很多读者的赞赏,但我看评论,还是发现了些问题,因为有不少读者是看了一遍又一遍,每次感觉都蛮好,可是隔一段时间,对&quot;委托和事件&quot;又迷糊了,于是又来看!我真搞不懂,为什么会出现这种情况!后来想想,文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3koWNb.html" rel="bookmark">艾伟&lowbar;转载：解惑答疑：C&num;委托和事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				相信很多人一直为C#委托和事件所困惑,尤其是C#的初学者,学到这一部分会感觉比较困难,很有可能就放弃了,而且.NET对委托和事件封装得挺好,一般都不怎么用到自定义的委托和事件,所以放弃学习该技术就有了借口! 网上也有不少此类的文章,最具代表性的是张子阳的C#中的委托和事件这篇,写得的确很好,得到很多读者的赞赏,但我 看评论,还是发现了些问题,因为有不少读者是看了一遍又一遍,每次感觉都蛮好,可是隔一段时间,对&quot;委托和事件&quot;又迷糊了,于是又来看!我真搞不懂,为什 么会出现这种情况!后来想想			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6QEdYb.html" rel="bookmark">关于律师你所不知道的五个真相</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 今年,不少新老法律电商都拿到了融资,法律这个古老的行业似乎在电商大潮的冲刷之下萌发出些许新枝芽. 作为律师这个古老行业中的一员,我无法预见未来法律电商的发展走向,但 今年,不少新老法律电商都拿到了融资,法律这个古老的行业似乎在电商大潮的冲刷之下萌发出些许新枝芽. 作为律师这个古老行业中的一员,我无法预见未来法律电商的发展走向,但就目前这个阶段而言,法律电商确实有不小的机会,但同时似乎也面临着很多法律和商业上的障碍需要突破,而这一切都是基于法律服务与其他服务或者产品相比所具有的特殊属性.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5xXaM.html" rel="bookmark">关于谷歌PR你可能不知道的一些事情</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PR一直以来都被很多站长当成是唯一衡量网站权重的标准,我们在交换友情链接,在评估竞争对手网站的价值时总理不开它,这反而让很多站长只过分注重于PR值还忽略了其他方方面面的优化因素.那么谷歌PR的哪些事情可能是你所不知道的呢? 1. PR只能评估网页外链数量和网页外链质量,并不能指代网页权重.换而言之,PR只与外链数量和质量相关,与其他因素无关. 2. 一个PR4.只拥有5个出站链接的网页要比一个PR8,但拥有100个出站链接的网页要有价值得多. 3. 从PR0到PR1相对容易些,从PR1到PR3会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8jaRlb.html" rel="bookmark">关于Java性能监控您不知道的5件事，第2部分：利用JDK内置分析器进行Java进程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于Java性能监控您不知道的5件事,第2部分:利用JDK内置分析器进行Java进程监控 全功能内置分析器,如 JConsole 和 VisualVM 的成本有时比它们的性能费用还要高 - 尤其是在生产软件上运行的系统中.因此,在聚焦 Java 性能监控的第 2 篇文章中,我将介绍 5 个命令行分析工具,使开发人员仅关注运行的 Java 进程的一个方面. JDK 包括很多命令行实用程序,可以用于监控和管理 Java 应用程序性能.虽然大多数这类应用程序都被标注为 &quot;实验型&quot;,在技术上不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balvgNz.html" rel="bookmark">关于Java Database Connectivity您不知道的5件事：提升您和JDBC API的关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于Java Database Connectivity您不知道的5件事:提升您和JDBC API的关系 目前,许多开发人员把 Java Database Connectivity (JDBC) API 当作一种数据访问平台,比如 Hibernate 或 SpringMany.然而 JDBC 在数据库连接中不仅仅充当后台角色.对于 JDBC,您了解的越多,您的 RDBMS 交互效率就越高. 在本期 5 件事 系列 中,我将向您介绍几种 JDBC 2.0 到 JDBC 4.0 中新引入的功能.设计			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0P0g6M.html" rel="bookmark">7大你可能不知道的Chrome使用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				微软IE一手遮天的时代已经一去不复返了,而在当下浏览器的&quot;战国割据&quot;中,近几年异军突起的 Google Chromium/Chrome 以及基于其衍生出的浏览器(如360极速.搜狗.枫树--)占据用户桌面的份额越来越大,因此极客公园整理了一些你可能不知道的使用技巧,可以让你更加快速熟练的使用 Chrome,让事情变得更简单,提高生活.工作.学习效率. 一. 快速关闭标签页 相信大多数人依旧是用鼠标直接点击那个关闭按钮来进行标签关闭的,你或许知道 Chrome 专门对标签关闭优化过,每次			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq8a2b.html" rel="bookmark" class="title">算法-递归问题，学习请教？求高人指点？字数够了吧！！！</a>
					<div>
						问题描述 递归问题,学习请教?求高人指点?字数够了吧!!! 今天研究了一些递归程序,简单点的递推过程还能想明白执行过程,复杂的就整不明白了,请问各位大神们需要认真的研究递归过程吗?是不是会用就行了啊?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8E7oz.html" rel="bookmark" class="title">动态产生XML文档的几种方式</a>
					<div>
						xml|动态 当今世界,技术发展迅猛,不论是什么行业,大多数关键数据都是放置于数据库中进行管理的,一来目前数据库技术已经相当成熟,二来其管理功能非常强大.以往的数据库应用,其数据底层结构一般来说都是相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAvGvp.html" rel="bookmark" class="title">Java Web 框架的&OpenCurlyDoubleQuote;甜点&rdquo;</a>
					<div>
						web 这是一篇很有趣的文档,所以摘要一下,其实类似阅读笔记,好像是3/25发布的:不知怎么翻译Sweet Spots,难道翻译为甜处.甜头.蜜点.蜜穴? 本文基于对以下人的采访(最后两位的看法独到还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKj47z.html" rel="bookmark" class="title">卢松松：网页速度可能不会影响搜索排名了</a>
					<div>
						网站加载速度受到很多因素的影响,地域,带宽以及网速等因素都会影响网站加载的速度.因此,若仅以&quot;网站速度&quot;来评判网站的用户体验似乎过于武断,谷歌Matt Cutts表示,会针对这一问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1OWdz.html" rel="bookmark" class="title">FLASH MX 2004视频教程&colon;宝泉奶粉广告制作&lpar;一&rpar;</a>
					<div>
						广告|教程|视频教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKO9db.html" rel="bookmark" class="title">让你成为更出色的PHP开发者的10个技巧</a>
					<div>
						Raphael Caixeta作为一个刚开始使用PHP的开发者,总结了十点PHP开发的技术,希望能对这门了不起的放言的初学者能有些帮助: 1.尽量使用PHP自带的核心函数和类 2.巧用配置文件 3.时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmk8lb.html" rel="bookmark" class="title">悦怀SEO：浅谈巧用锚文本做高质量外链的小技巧</a>
					<div>
						网站优化分两方面,一方面是站内优化,另一方面就是站外优化,其中外链在优化网站排名中起着至关重要的作用.每个人都会做外链,但是做高质量收录的外链就并非是件易事.这也是大部分SEO初学者经常会问的问题,怎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MW9Zrz.html" rel="bookmark" class="title">以seo角度浅谈网站导航需要考虑几点因素</a>
					<div>
						网站导航作为网站设计中是不可缺少一个部分,如果没有了导航网站用户就无法快速找到用户想要的信息.网站的导航的存在的价值,不仅便利用户寻找信息更快的找到相关栏目下的内容,而切也有利搜索引擎的抓取,从而有效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQewZb.html" rel="bookmark" class="title">图解影响添加至百度首页按钮出现要素</a>
					<div>
						上周发现了百度首页出现了一个导航栏目,当时也没太在意.直至今天小叶才忽然发现,百度一些关键词时有会一个添加至百度首页的按钮.让小叶想起了百度分享时,是否也有着异曲同妙之处呢?于是,小叶如何出现这按钮进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOB5ZM.html" rel="bookmark" class="title">WPS表格中批量改换单元格数据格式</a>
					<div>
						前两天,同事找我帮忙.如图1所示,她的ET中有一栏&quot;出生日期&quot;,当初录入数据时单元格格式为&quot;常规&quot;,格式统一为&quot;1980.9.16&quot;.现在根 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB25PNb.html" rel="bookmark" class="title">JSF与Struts框架的异同</a>
					<div>
						Struts和JSF/Tapestry都属于表现层框架,这两种分属不同性质的框架,后者是一种事件驱动型的组件模型,而Struts只是单纯的MVC模式框架,我们下面进行详细分析比较. 首先事件是指从客户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze483Vp.html" rel="bookmark" class="title">调用HttpHanlder的几种返回方式</a>
					<div>
						 本篇文章主要是对调用HttpHanlder的几种返回方式进行了总结介绍,需要的朋友可以过来参考下,希望对大家有所帮助 1:如果只需要返回字符串形式的 例如内容.JSON字符串数组等   contex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWaxmb.html" rel="bookmark" class="title">在DOS下安装WindowsXP系统的方法介绍</a>
					<div>
						前几天朋友在安装Windows XP时问我,格式化机器,用启动盘进入DOS环境后,安装Windows XP速度特别慢,问我是怎么回事,当我问他运行Smartdrv.exe文件没有,朋友很茫然地看着我, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YYRAM.html" rel="bookmark" class="title">http-android post方式向服务器传递数据</a>
					<div>
						问题描述 android post方式向服务器传递数据 我做登陆,后台服务器是用php写的,登陆成功后就echo &quot;success&quot;,客户端接收代码如下,用的是字节流的方式,但为什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7L0Oz.html" rel="bookmark" class="title">CSS之旅&mdash;&mdash;第二站 如何更深入的理解各种选择器</a>
					<div>
						上篇我们说了为什么要使用css,这篇我们就从选择器说起,大家都知道浏览器会把远端过来的html解析成dom模型,有了dom模型,html就变成 了xml格式,否则的话就是一堆&quot;杂乱无章&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2GrEb.html" rel="bookmark" class="title">应用迁云之镜像迁移-（4）迁移到阿里云实施流程和实践方法</a>
					<div>
						镜像迁移到阿里云实施流程   1.Â Â Â Â Â Â  镜像迁移可行性评估 当我们选择镜像迁移前需要对被迁移的服务器主机详细信息进行调研按照镜像迁移可行性评估小节中描述的要求及限制进行评估评估是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoORBb.html" rel="bookmark" class="title">阿里云邮箱登录日志中有异地IP登录是怎么回事？该怎么办？</a>
					<div>
						注意,请先到阿里云官网 领取幸运券,除了价格上有很多优惠外,还可以参与抽奖.详见:https://promotion.aliyun.com/ntms/act/ambassador/sharetouse ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm4mvz.html" rel="bookmark" class="title">rails新建应用，改用镜像网站总是失败</a>
					<div>
						问题描述 rails新建应用,改用镜像网站总是失败 Rails安装成功,使用rails new abc时运行到bundle卡住不动,按照网上方法把rubygems改成https://ruby.taob ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NDyRz.html" rel="bookmark" class="title">在扁平的世界中协作&colon; 协作开发工具</a>
					<div>
						本文讲的是在扁平的世界中协作: 协作开发工具,[IT168 资讯]软件开发领域的协作包含了大范围的团队活动,从在同一个地方的小型项目的团队开发,到涉及三个或更多时区以及数百个开发人员的地理上分布的项目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQwDqp.html" rel="bookmark" class="title">阻塞模式和非阻塞模式</a>
					<div>
						好文得转~~~ 何为阻塞?  从该网络通讯过程来理解一下何为阻塞 :  在以上过程中若连接还没到来,那么 accept 会阻塞 , 程序运行到这里不得不挂起, CPU 转而执行其他线程.  在以上过程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NZX1M.html" rel="bookmark" class="title">sublime text3 有没有类似atom那种代码提示插件？</a>
					<div>
						问题描述 sublime text3 有没有类似atom那种代码提示插件? 已经装了emmet,在写HTML的时候 一定要写&lt;才会出现提示代码 比如我要写个div,在atom里直接打di 就会提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Zm7OM.html" rel="bookmark" class="title">Windows 8实例教程系列 - 自定义应用风格</a>
					<div>
						原文:Windows 8实例教程系列 - 自定义应用风格 在Windows 8 XAML实例教程中,曾经提及过应用风格设计方法以及如何创建可复用样式代码.本篇将深入讨论如何创建自定义Windows8应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKv5kz.html" rel="bookmark" class="title">理解C语言&mdash;&mdash;从小菜到大神的晋级之路（15）&mdash;&mdash;完结篇：C编程风格</a>
					<div>
						本期视频链接:点击这里 有人说过:&quot;程序源代码其实是跟人阅读的,只是恰好机器可以编译而已&quot;.编程初学者常常会有这样一个观念,就是我的程序只要编译通过了,运行没有问题那就万事大吉了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBEdlb.html" rel="bookmark" class="title">Triptrotting：让当地人陪你旅行</a>
					<div>
						正如聚餐网站http://www.aliyun.com/zixun/aggregation/16624.html&quot;&gt;Grubwithus让美食爱好者能够以饭局会友寻找同道中人,创业公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKlPZz.html" rel="bookmark" class="title">java-Java中try&period;&period;&period;&period;catch语句除了可以捕获异常并输出异常信息，还有什么用呢</a>
					<div>
						问题描述 Java中try....catch语句除了可以捕获异常并输出异常信息,还有什么用呢 Java中try....catch语句除了可以捕获异常并输出异常信息,还有什么用呢 解决方案 catch语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5j4Op.html" rel="bookmark" class="title">阿米尼电动车被曝轮胎频开裂电池漏电快</a>
					<div>
						女报记者 匡名梅 实习生 吴凡 杨宝成 &quot;电动车使用半年多,轮胎坏了好几次&quot;&quot;电瓶频繁放电,要雇车拉着去维修&quot;.近日,多位市民向都市女报诉说购买阿米尼牌电动车后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoXa8M.html" rel="bookmark" class="title">JavaScript语言基础知识点图示</a>
					<div>
						原文:JavaScript语言基础知识点图示 一位牛人归纳的JavaScript 语言基础知识点图示. 1.JavaScript 数据类型     2.JavaScript 变量     3.Java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkjEmM.html" rel="bookmark" class="title">如何根据不同的用户使用不同的jdbcTemplate数据源？</a>
					<div>
						问题描述 公司有一项目,使用的是spring JDBCTemplate 作为数据库连接池,现在需求变更了,需要根据不同的用户访问不同的数据源.根据用户找出数据库名很容易办到,现在的问题是如何如何在不同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqE8Op.html" rel="bookmark" class="title">原生的强大DOM选择器querySelector介绍&lowbar;基础知识</a>
					<div>
						在传统的 JavaScript 开发中,查找 DOM 往往是开发人员遇到的第一个头疼的问题,原生的 JavaScript 所提供的 DOM 选择方法并不多,仅仅局限于通过 tag, name, id  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRd7PBz.html" rel="bookmark" class="title">产妇吹空调姿势盘点引共鸣天樽再成焦点</a>
					<div>
						难道为了预防空调病,只能开着风扇吹空调?近日一则吐槽&quot;产妇吹空调奇葩姿势&quot;的微博引起 网友的关注.该微博盘点了为了既要凉爽,又避免对产妇身体造成伤害的各种吹空调方式:盖着被子吹.穿 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
